#include <termios.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/time.h>
#include <fcntl.h>

#include <servo.h>
#include <ik.h>
#include <ssc32.h>

int
main(int argc, char **argv) {
   int fd;
   int i,l;
   char c,o; 
   struct termios t;
   int step=1;

   printf("welcome.\n");
   comm_open("/dev/tty.BT-ECU2-S-DevB");

   for(i=0;i<NUM_SERVOS;i++) { servo_pwm[i]=servo_zero_pwm[i]; servo_angle[i]=0.0f; servo_current_angle[i]=1000.0f;}
   comm_update_servos(0.3f);

   tcgetattr(0,&t);
   t.c_lflag&=~(ICANON|ECHO|ECHOE|ISIG);
   tcsetattr(0,TCSANOW,&t);

   l=0;

   do {
      system ("clear");
      // calculate current angale to pwm factor
      for(i=0;i<NUM_SERVOS;i++) {
      servo_factor[i]=(servo_max_pwm[i]-servo_min_pwm[i])/(servo_max_angle[i]-servo_min_angle[i]);
      }

      printf("Current  : servo_angle (servo_pwm)");
      for(i=0;i<NUM_SERVOS;i++) {
         if(!(i%3)) {
            printf("\n");
            if((i/3)==l) {
                  printf(" > "); 
            } else {
                  printf("   "); 
            }
         }
         printf("%.1f (%04d)",servo_angle[i],servo_pwm[i]);
      }
      printf("\nZero  : servo_zero_angle (servo_zero_pwm)");
      for(i=0;i<NUM_SERVOS;i++) {
         if(!(i%3)) {
            printf("\n");
            if((i/3)==l) {
                  printf(" > "); 
            } else {
                  printf("   "); 
            }
         }
         printf("0.0 (%04d)",servo_zero_pwm[i]);
      }
      printf("\nMin  : servo_min_angle (servo_min_pwm)");
      for(i=0;i<NUM_SERVOS;i++) {
         if(!(i%3)) {
            printf("\n");
            if((i/3)==l) {
                  printf(" > "); 
            } else {
                  printf("   "); 
            }
         }
         printf("%.1f (%04d)",servo_min_angle[i],servo_min_pwm[i]);
      }
      printf("\nMax  : servo_max_angle (servo_max_pwm)");
      for(i=0;i<NUM_SERVOS;i++) {
         if(!(i%3)) {
            printf("\n");
            if((i/3)==l) {
                  printf(" > "); 
            } else {
                  printf("   "); 
            }
         }
         printf("%.1f (%04d)",servo_max_angle[i],servo_max_pwm[i]);
      }
      printf("\nFactor  : servo angle to pwm");
      for(i=0;i<NUM_SERVOS;i++) {
         if(!(i%3)) {
            printf("\n");
            if((i/3)==l) {
                  printf(" > "); 
            } else {
                  printf("   "); 
            }
         }
         printf("%.2f   ",servo_factor[i]);
      }

       printf("\n\n a/z d/c g/b: move vmodel target angle \n s/x f/v h/n: move servo pwm value \n =-: select leg(%d)\n[]: increase/decrease step size (%d)\ne: dump\nr/w: read/write calibration.bin\n,/l/.: write current leg value as (min/zero/max)\n j/i/k:set leg to min/zero/max\nq: quit\n> ",l,step);
       c=getchar();
       printf("%c (%02x)\n",c,c);
       o=' ';
       switch(c) {
          // angle step
          case 'a':
             servo_angle[l*3]+=step;
             o='a';
             break;
          case 'z': 
             servo_angle[l*3]-=step;
             o='a';
             break;
          case 'd': 
             servo_angle[l*3+1]+=step;
             o='a';
             break;
          case 'c': 
             servo_angle[l*3+1]-=step;
             o='a';
             break;
          case 'g': 
             servo_angle[l*3+2]+=step;
             o='a';
             break;
          case 'b': 
             servo_angle[l*3+2]-=step;
             o='a';
             break;
          // pwm step
          case 's':
             servo_pwm[l*3]+=step*servo_direction[l*3];
             o='p';
             break;
          case 'x':
             servo_pwm[l*3]-=step*servo_direction[l*3];
             o='p';
             break;
          case 'f':
             servo_pwm[l*3+1]+=step*servo_direction[l*3+1];
             o='p';
             break;
          case 'v':
             servo_pwm[l*3+1]-=step*servo_direction[l*3+1];
             o='p';
             break;
          case 'h':
             servo_pwm[l*3+2]+=step*servo_direction[l*3+2];
             o='p';
             break;
          case 'n':
             servo_pwm[l*3+2]-=step*servo_direction[l*3+2];
             o='p';
             break;
         // servo select
         case '=':
             if((l+1)<NUM_LEGS) l++;
             break;
          case '-':
             if(l>0) l--;
             break;
          case '[':
             if(step>=10) step/=10;
             break;
          case ']':
             step*=10;
             break;
          case 'l':
             //zero
             servo_zero_pwm[l*3]=servo_pwm[l*3];
             servo_zero_pwm[l*3+1]=servo_pwm[l*3+1];
             servo_zero_pwm[l*3+2]=servo_pwm[l*3+2];
             break;
          case ',':
             //min
             servo_min_pwm[l*3]=servo_pwm[l*3];
             servo_min_pwm[l*3+1]=servo_pwm[l*3+1];
             servo_min_pwm[l*3+2]=servo_pwm[l*3+2];
             servo_min_angle[l*3]=servo_angle[l*3];
             servo_min_angle[l*3+1]=servo_angle[l*3+1];
             servo_min_angle[l*3+2]=servo_angle[l*3+2];
             break;
          case '.':
             //max
             servo_max_pwm[l*3]=servo_pwm[l*3];
             servo_max_pwm[l*3+1]=servo_pwm[l*3+1];
             servo_max_pwm[l*3+2]=servo_pwm[l*3+2];
             servo_max_angle[l*3]=servo_angle[l*3];
             servo_max_angle[l*3+1]=servo_angle[l*3+1];
             servo_max_angle[l*3+2]=servo_angle[l*3+2];
             break;
          case 'i':
             //zero
             servo_pwm[l*3]=servo_zero_pwm[l*3];
             servo_pwm[l*3+1]=servo_zero_pwm[l*3+1];
             servo_pwm[l*3+2]=servo_zero_pwm[l*3+2];
             servo_angle[l*3]=0.0f;
             servo_angle[l*3+1]=0.0f;
             servo_angle[l*3+2]=0.0f;
             o='p';
             break;
          case 'j':
             //min
             servo_pwm[l*3]=servo_min_pwm[l*3];
             servo_pwm[l*3+1]=servo_min_pwm[l*3+1];
             servo_pwm[l*3+2]=servo_min_pwm[l*3+2];
             servo_angle[l*3]=servo_min_angle[l*3];
             servo_angle[l*3+1]=servo_min_angle[l*3+1];
             servo_angle[l*3+2]=servo_min_angle[l*3+2];
             o='p';
             break;
          case 'k':
             //max
             servo_pwm[l*3]=servo_max_pwm[l*3];
             servo_pwm[l*3+1]=servo_max_pwm[l*3+1];
             servo_pwm[l*3+2]=servo_max_pwm[l*3+2];
             servo_angle[l*3]=servo_max_angle[l*3];
             servo_angle[l*3+1]=servo_max_angle[l*3+1];
             servo_angle[l*3+2]=servo_max_angle[l*3+2];
             o='p';
             break;
          case 'e':
//             fd=open("calibration.c",O_WRONLY|O_CREAT|O_TRUNC,0644);
//             if(fd!=-1) {
//              write(fd,servo_zero_pwm,sizeof(servo_zero_pwm));

             printf("/* Servo zerro offset pwm value */\n\nuint16_t servo_zero_pwm[NUM_SERVOS]={");
             for(i=0;i<NUM_SERVOS;i++) {
                if(!(i%3)) printf("\n");
                printf(" %4d,",servo_zero_pwm[i]);
             }
             printf("\n};\n\n");
             printf("/* Servo min pwm value */\n\nuint16_t servo_min_pwm[NUM_SERVOS]={");
             for(i=0;i<NUM_SERVOS;i++) {
                if(!(i%3)) printf("\n");
                printf(" %4d,",servo_min_pwm[i]);
             }
             printf("\n};\n\n");
             printf("/* Servo max pwm value */\n\nuint16_t servo_max_pwm[NUM_SERVOS]={");
             for(i=0;i<NUM_SERVOS;i++) {
                if(!(i%3)) printf("\n");
                printf(" %4d,",servo_max_pwm[i]);
             }
             printf("\n};\n\n");
             printf("/* Servo min angle value */\n\nfloat servo_min_angle[NUM_SERVOS]={");
             for(i=0;i<NUM_SERVOS;i++) {
                if(!(i%3)) printf("\n");
                printf(" %.1ff,",servo_min_angle[i]);
             }
             printf("\n};\n\n");
             printf("/* Servo max angle value */\n\nfloat servo_max_angle[NUM_SERVOS]={");
             for(i=0;i<NUM_SERVOS;i++) {
                if(!(i%3)) printf("\n");
                printf(" %.1ff,",servo_max_angle[i]);
             }
             printf("\n};\n\n");
             printf("/* Servo angle to pwm factor */\n\nfloat servo_factor[NUM_SERVOS]={");
             for(i=0;i<NUM_SERVOS;i++) {
                if(!(i%3)) printf("\n");
                printf(" %.2ff,",servo_factor[i]);
             }
             printf("\n};\n\n");
//             close(fd);
//             };
             printf("/* press any key */\n");
             getchar();
             break;
          case 'w':
             fd=open("calibration.bin",O_WRONLY|O_CREAT|O_TRUNC,0644);
             if(fd!=-1) {
              write(fd,servo_zero_pwm,sizeof(servo_zero_pwm));
              write(fd,servo_min_pwm,sizeof(servo_min_pwm));
              write(fd,servo_max_pwm,sizeof(servo_max_pwm));
              write(fd,servo_min_angle,sizeof(servo_min_angle));
              write(fd,servo_max_angle,sizeof(servo_max_angle));
              write(fd,servo_factor,sizeof(servo_factor));
             close(fd);
             };
             break;
          case 'r':
             load_calibration("calibration.bin");
             break;
       }

       switch(o) {
          case 'a' : comm_update_servos(1); break;
          case 'p' : comm_update_servos_pwm(1); break;
       }
   } while(c!='q');

   comm_close();

   tcgetattr(0,&t);
   t.c_lflag|=(ICANON|ECHO|ECHOE|ISIG);
   tcsetattr(0,TCSANOW,&t);
}

