#ifndef _LICKS_SSC32_H
#define _LICKS_SSC32_H

#include <stdint.h>

#define SSC32_BUSY   0x2B //+
#define SSC32_DONE   0x2E //.
#define SSC32_ERR    0x22 //"ERROR"

#define CMD_SET_SERVOS 0x23 // #
#define CMD_SET_SERVOS_PWM 0x50 // P
#define CMD_SET_SERVOS_SPEED 0x53 // S
#define CMD_SET_SERVOS_TIME 0x54 // T


//#define CMD_NOP        0x00
#define CMD_CONTINUE   0x0A // Enter
//#define CMD_FINISH     0x02
//#define CMD_CLEAR      0x8A

#define CMD_GET_STATUS 0x51 //Q

extern void comm_open(char ssc32_device[255]);
extern void comm_update_servos(uint16_t time);
extern void comm_update_servos_pwm(uint16_t time);
extern void comm_set_led(uint8_t);
extern void comm_set_laser(uint8_t);
extern void comm_close();

struct ssc32_message {
   uint8_t length;
   char cmd[255];
};

struct ssc32_result {
   uint8_t status;
   uint8_t length;
   char data[255];
};

#endif
